import 'package:diplomaticquarterapp/core/viewModels/medical/weight_pressure_view_model.dart';
import 'package:diplomaticquarterapp/core/viewModels/project_view_model.dart';
import 'package:diplomaticquarterapp/pages/medical/my_trackers/widget/LineChartCurved.dart';
import 'package:diplomaticquarterapp/uitl/date_uitl.dart';
import 'package:diplomaticquarterapp/uitl/translations_delegate_base.dart';
import 'package:diplomaticquarterapp/widgets/charts/app_time_series_chart.dart';
import 'package:diplomaticquarterapp/widgets/data_display/text.dart';
import 'package:diplomaticquarterapp/widgets/others/app_scaffold_widget.dart';
import 'package:diplomaticquarterapp/widgets/transitions/fade_page.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:charts_flutter/flutter.dart' as charts;
import 'package:hexcolor/hexcolor.dart';
import 'package:provider/provider.dart';

import 'AddWeightPage.dart';

class WeightWeeklyPage extends StatelessWidget {
  final WeightPressureViewModel model;

  const WeightWeeklyPage({Key key, this.model}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    ProjectViewModel projectViewModel = Provider.of(context);

    return AppScaffold(
      isShowDecPage: false,
      body: ListView(
              children: [
                Container(
                  margin: EdgeInsets.only(top: 12, left: 8, right: 8),
                  color: Colors.white,
                  child: LineChartCurved(
                    horizontalInterval: 1.0,
                    title: TranslationBase.of(context).weight,
                    timeSeries: model.weightWeekTimeSeriesData.isEmpty
                        ? [TimeSeriesSales2(DateTime.now(), 0.0)]
                        : model.weightWeekTimeSeriesData,
                    indexes: model.weightWeekTimeSeriesData.length ~/ 5.5 ?? 0,
                  ),
                ),
                SizedBox(
                  height: 12,
                ),
                Padding(
                  padding: const EdgeInsets.all(8.0),
                  child: Texts(TranslationBase.of(context).details),
                ),
                Container(
                  padding: EdgeInsets.all(10),
                  color: Colors.transparent,
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: <Widget>[
                      model.weightWeekTimeSeriesData.isEmpty? Container(
                        child: Center(
                          child: Texts(TranslationBase.of(context).noDataAvailable),
                        ),
                      ):Table(
                        border: TableBorder.symmetric(
                          inside:
                              BorderSide(width: 2.0, color: Colors.grey[300]),
                        ),
                        children: fullData(context, projectViewModel, model),
                      ),
                    ],
                  ),
                )
              ],
            ),
    );
  }

  List<TableRow> fullData(BuildContext context,
      ProjectViewModel projectViewModel, WeightPressureViewModel model) {
    List<TableRow> tableRow = [];
    tableRow.add(
      TableRow(
        children: [
          Container(
            decoration: BoxDecoration(
              color: Theme.of(context).primaryColor,
              borderRadius: BorderRadius.only(
                topLeft: projectViewModel.isArabic
                    ? Radius.circular(0.0)
                    : Radius.circular(10.0),
                topRight: projectViewModel.isArabic
                    ? Radius.circular(10.0)
                    : Radius.circular(0.0),
              ),
            ),
            child: Center(
              child: Texts(
                TranslationBase.of(context).date,
                color: Colors.white,
                fontSize: 15,
              ),
            ),
            height: 40,
          ),
          Container(
              decoration: BoxDecoration(
                color: Theme.of(context).primaryColor,
              ),
              child: Center(
                child: Texts(
                  TranslationBase.of(context).time,
                  color: Colors.white,
                  fontSize: 15,
                ),
              ),
              height: 40),
          Container(
              decoration: BoxDecoration(
                color: Theme.of(context).primaryColor,
              ),
              child: Center(
                child: Texts(
                  TranslationBase.of(context).value,
                  color: Colors.white,
                  fontSize: 15,
                ),
              ),
              height: 40),
          Container(
              decoration: BoxDecoration(
                color: Theme.of(context).primaryColor,
                borderRadius: BorderRadius.only(
                  topLeft: projectViewModel.isArabic
                      ? Radius.circular(10.0)
                      : Radius.circular(0.0),
                  topRight: projectViewModel.isArabic
                      ? Radius.circular(0.0)
                      : Radius.circular(10.0),
                ),
              ),
              child: Center(
                child: Texts(
                  TranslationBase.of(context).edit,
                  color: Colors.white,
                  fontSize: 15,
                ),
              ),
              height: 40),
        ],
      ),
    );
    model.weekWeightMeasurementResult.forEach(
      (diabtec) {
        tableRow.add(
          TableRow(
            children: [
              Container(
                child: Container(
                  height: 70,
                  padding: EdgeInsets.all(10),
                  color: Colors.white,
                  child: Center(
                    child: Texts(
                      '${projectViewModel.isArabic ? DateUtil.getMonthDayYearDateFormattedAr(diabtec.weightDate) : DateUtil.getMonthDayYearDateFormatted(diabtec.weightDate)} ',
                      textAlign: TextAlign.center,
                      fontSize: 12,
                    ),
                  ),
                ),
              ),
              Container(
                height: 70,
                padding: EdgeInsets.all(10),
                color: Colors.white,
                child: Center(
                  child: Texts(
                    '${diabtec.weightDate.hour}:${diabtec.weightDate.minute}',
                    textAlign: TextAlign.center,
                    fontSize: 12,
                  ),
                ),
              ),
              Container(
                child: Container(
                  height: 70,
                  padding: EdgeInsets.all(10),
                  color: Colors.white,
                  child: Center(
                    child: Texts(
                      '${diabtec.weightMeasured}',
                      textAlign: TextAlign.center,
                      fontSize: 12,
                    ),
                  ),
                ),
              ),
              InkWell(
                onTap: () {
                  Navigator.push(
                    context,
                    FadePage(
                      page: AddWeightPage(
                        isUpdate: true,
                        dayWeightDate: diabtec.weightDate,
                        measureTimeSelectedType: 'Kg',
                        weightValue: diabtec.weightMeasured.toString(),
                        lineItemNo: diabtec.lineItemNo,
                        weightUnit: int.parse(diabtec.unit),
                        model: model,
                      ),
                    ),
                  );
                },
                child: Container(
                  height: 70,
                  padding: EdgeInsets.all(10),
                  color: Colors.white,
                  child: Center(
                    child: Icon(Icons.edit),
                  ),
                ),
              ),
            ],
          ),
        );
      },
    );
    return tableRow;
  }
}
